var _a;
import LoreParser from 'lore-manager/lore-parser/lore.parser';
import { weaponTemplate } from 'lore-manager/lore-parser/templates/weapons.template';
class LoreHandler {
    static apply(item) {
        item?.setLore();
    }
    static setAmmoOnCurrentLore(item, n) {
        const lp = new LoreParser(item);
        lp.for(weaponTemplate).set('ammo', n);
        lp.updateLore();
        return lp.itemStack;
    }
    static getIntFromLore(item, key) {
        return 0;
    }
    static getStringFromLore(item, key) {
        if (item.getLore().length === 0)
            return null;
        for (let i = 2; i < this.shape.length - 2; i++) {
            let loreLine = item.getLore()[i];
            if (this.shape[i].includes(`{${key}}`))
                return loreLine.replace(this.shape[i].split(`{${key}}`)[0], '');
        }
        return null;
    }
    static getValueFromLore(item, key, shape = this.shape, remove = 2) {
        for (let i = 2; i < shape.length - remove; i++) {
            let loreLine = item?.getLore()[i];
            const onlyNumberRegex = /\d+/g;
            const extracted = loreLine?.replace(shape[i]?.split(`{${key}}`)[0], '');
            const number = extracted?.match(onlyNumberRegex);
            return number && parseInt(number[0]);
        }
        return 0;
    }
    static setValueOnLore(key, value, item) {
        const lp = new LoreParser(item);
        lp.for(weaponTemplate).set(key, value);
        lp.updateLore();
        return item;
    }
    static setValueOnCurrentLore(key, value, item) {
        const lp = new LoreParser(item);
        lp.for(weaponTemplate).set(key, value);
        lp.updateLore();
        return item;
    }
    static getValueApplyToShape(key, value, shape = this.shape) {
        return this.applyClearLoreToShape(shape.map((line) => line.length <= 50 && line.replace(`{${key}}`, typeof value === 'string' ? value : value.toString())));
    }
    static getShapedLore(values) {
        let finalShape = this.shape;
        for (let i = 0; i < Object.keys(values).length; i++) {
            const key = Object.keys(values)[i];
            finalShape = finalShape.map((line) => {
                if (line.length > 50)
                    return;
                if (line?.includes(key))
                    return line.replaceAll(`{${key}}`, values[key]);
                else
                    return line;
            });
        }
        return this.applyClearLoreToShape(finalShape);
    }
    static applyClearLoreToShape(value) {
        return value.map((line) => this.getClearLore() + line.replaceAll('§r§j', ''));
    }
    static getClearLore() {
        return '§r§j';
    }
}
_a = LoreHandler;
LoreHandler.UNIQUE_ID = '§w§e§a§p§o§n';
LoreHandler.COLOR_REMOVER_REGEX = /§./g;
LoreHandler.shape = [
    '┌─',
    '│',
    '│ §7Ammo §8: §h{ammo}',
    '│ §7Skin §8: §h{skinName}',
    '│ §7Attachements §8: §h{attachements}',
    '│',
    '└─ ',
    _a.UNIQUE_ID,
];
export default LoreHandler;
