import MeleeWeapon from 'melee/melee-weapon';
export default class Balisong extends MeleeWeapon {
    constructor() {
        super(...arguments);
        this.itemTypeId = 'melee:balisong'; //'melee:seal';
        // MAIN GUN PROPERTIES
        this.name = 'Balisong Knife';
        this.drawTime = 900; // in ms
        this.displayDrawCooldown = true;
        this.leftAttack = {
            enabled: true,
            damages: 6,
            delay: 0,
            cooldown: 4.5,
            displayCooldown: true,
            range: 5,
            precision: 0.07,
            sounds: {
                onHitBlock: {
                    soundIds: ['cso.balisong.wall'],
                    pitch: 1,
                    volume: 1.5,
                },
                onHitEntity: {
                    soundIds: ['cso.balisong.hit'],
                    pitch: 1,
                    volume: 1.5,
                },
                onMiss: {
                    soundIds: [''],
                    pitch: 0.5,
                    volume: 100,
                },
            },
            particles: {
                onHitBlock: {
                    particleIds: ['move:tiger', 'move:tiger'],
                },
                onHitEntity: {
                    particleIds: ['ag:blood', 'knife:sweep'],
                },
            },
        };
        this.rightAttack = {
            enabled: false,
        };
        // ATTACK on draw
        this.initialAttack = {
            enabled: false,
        };
        this.sounds = {
            onDraw: {
                soundIds: [],
                pitch: 2,
                volume: 100,
            },
        };
        this.particles = {
            onDraw: {
                particleIds: [],
            },
        };
        // Charge System
        this.charges = {
            enabled: false,
        };
        // KNOCKBACK
        this.knockback = {
            Ximpusle: 0.7,
            Zimpusle: 0.3,
        };
    }
}
