import MeleeWeapon from 'melee/melee-weapon';
export default class bat extends MeleeWeapon {
    constructor() {
        super(...arguments);
        this.itemTypeId = 'melee:bat'; //'melee:seal';
        // MAIN GUN PROPERTIES
        this.name = 'bat';
        this.drawTime = 1050; // in ms
        this.displayDrawCooldown = true;
        this.leftAttack = {
            enabled: true,
            damages: 4,
            delay: 3,
            cooldown: 8,
            displayCooldown: true,
            range: 4.8,
            precision: 0.07,
            knockback: {
                Ximpusle: 0.7,
                Zimpusle: 0.6,
            },
            sounds: {
                onHitBlock: {
                    soundIds: ['cso.bat.wall'],
                    pitch: 1,
                    volume: 1.5,
                },
                onHitEntity: {
                    soundIds: ['cso.bat.hit', 'gun.bonk'],
                    pitch: 1,
                    volume: 1.5,
                },
                onMiss: {
                    soundIds: [''],
                    pitch: 0.5,
                    volume: 100,
                },
            },
            particles: {
                onHitBlock: {
                    particleIds: ['move:tiger', 'move:tiger'],
                },
                onHitEntity: {
                    particleIds: ['ag:blood'],
                },
            },
        };
        this.rightAttack = {
            enabled: false,
        };
        // ATTACK on draw
        this.initialAttack = {
            enabled: false,
        };
        this.sounds = {
            onDraw: {
                soundIds: [],
                pitch: 2,
                volume: 100,
            },
        };
        this.particles = {
            onDraw: {
                particleIds: [],
            },
        };
        // Charge System
        this.charges = {
            enabled: false,
        };
    }
}
