import MeleeWeapon from 'melee/melee-weapon';
export default class hammer extends MeleeWeapon {
    constructor() {
        super(...arguments);
        this.itemTypeId = 'melee:hammer';
        // MAIN MELEE PROPERTIES
        this.name = 'Hammer';
        this.drawTime = 1300; // in ms
        this.displayDrawCooldown = true;
        this.leftAttack = {
            enabled: true,
            damages: 19,
            delay: 20,
            displayCooldown: true,
            cooldown: 36,
            range: 2.3,
            precision: 0.07,
            knockback: {
                Ximpusle: 0.9,
                Zimpusle: 0.4,
            },
            sounds: {
                onHitBlock: {
                    soundIds: ['cso.skullaxe.wall'],
                    pitch: 2,
                    volume: 1.5,
                },
                onHitEntity: {
                    soundIds: ['cso.hammer.slash'],
                    pitch: 1,
                    volume: 1.5,
                },
                onMiss: {
                    soundIds: [''],
                    pitch: 1,
                    volume: 1.5,
                },
            },
            particles: {
                onHitBlock: {
                    particleIds: ['move:tiger', 'hit:bullet5', 'move:tiger', 'move:tiger', 'move:tiger'],
                },
                onHitEntity: {
                    particleIds: ['azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood'],
                },
            },
            functions : {
                onHitEntity : ['hammer_hit']
            }
        };
        this.rightAttack = {
            enabled: true,
            damages: 25,
            delay: 20,
            displayCooldown: true,
            cooldown: 36,
            range: 2.3,
            precision: 0.07,
            knockback: {
                Ximpusle: 1.6,
                Zimpusle: 0.4,
            },
            sounds: {
                onHitBlock: {
                    soundIds: ['cso.skullaxe.wall'],
                    pitch: 2,
                    volume: 1.5,
                },
                onHitEntity: {
                    soundIds: ['cso.hammer.stab'],
                    pitch: 1,
                    volume: 1.5,
                },
                onMiss: {
                    soundIds: [''],
                    pitch: 1,
                    volume: 1.5,
                },
            },
            particles: {
                onHitBlock: {
                    particleIds: ['move:tiger', 'hit:bullet5', 'move:tiger', 'move:tiger', 'move:tiger'],
                },
                onHitEntity: {
                    particleIds: ['azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood'],
                },
            },
            functions : {
                onHitEntity : ['hammer_stab']
            }
        };
        // ATTACK on draw
        this.initialAttack = {
            enabled: false,
        };
        this.sounds = {
            onDraw: {
                soundIds: [''],
                pitch: 1,
                volume: 0.2,
            },
        };
        this.particles = {
            onDraw: {
                particleIds: [''],
            },
        };
        // Charge System
        this.charges = {
            enabled: false,
        };
        // KNOCKBACK
        this.knockback = {
            Ximpusle: 0.7,
            Zimpusle: 0.3,
        };
    }
}
