import MeleeWeapon from 'melee/melee-weapon';
export default class Taser extends MeleeWeapon {
    constructor() {
        super(...arguments);
        this.itemTypeId = 'melee:taser';
        // MAIN MELEE PROPERTIES
        this.name = 'Taser Knife';
        this.drawTime = 1050; // in ms
        this.displayDrawCooldown = true;
        this.leftAttack = {
            enabled: true,
            damages: 7,
            delay: 0,
            displayCooldown: true,
            cooldown: 5,
            range: 5,
            precision: 0.07,
            sounds: {
                onHitBlock: {
                    soundIds: ['cso.taser.wall'],
                    pitch: 1,
                    volume: 1.5,
                },
                onHitEntity: {
                    soundIds: ['cso.taser.hit'],
                    pitch: 1,
                    volume: 1.5,
                },
                onMiss: {
                    soundIds: [''],
                    pitch: 1,
                    volume: 1.5,
                },  
            },
            particles: {
                onHitBlock: {
                    particleIds: ['hit:bullet5', 'azoz:electro2_wall'],
                },
                onHitEntity: {
                    particleIds: ['ag:blood', 'knife:sweep', 'azoz:electro2'],
                },
            },
            functions : {
                onHitEntity : ['taser_hit']
            }
        };
        this.rightAttack = {
            enabled: false,
        };
        // ATTACK on draw
        this.initialAttack = {
            enabled: false,
        };
        this.sounds = {
            onDraw: {
                soundIds: [''],
                pitch: 1,
                volume: 0.2,
            },
        };
        this.particles = {
            onDraw: {
                particleIds: ['azoz:electro2_draw'],
            },
        };
        // Charge System
        this.charges = {
            enabled: false,
        };
        // KNOCKBACK
        this.knockback = {
            Ximpusle: 0.7,
            Zimpusle: 0.3,
        };
    }
}
