import MeleeWeapon from 'melee/melee-weapon';
export default class warhammer extends MeleeWeapon {
    constructor() {
        super(...arguments);
        this.itemTypeId = 'melee:warhammer';
        // MAIN MELEE PROPERTIES
        this.name = 'warhammer';
        this.drawTime = 300; // in ms
        this.displayDrawCooldown = true;
        this.leftAttack = {
            enabled: true,
            damages: 59,
            delay: 20,
            displayCooldown: true,
            cooldown: 56,
            range: 4,
            precision: 0.07,
            knockback: {
                Ximpusle: 0.9,
                Zimpusle: 0.4,
            },
            sideAttack: {
                timeToSlash: 150, // in ms
                rayPerLine: 20,
                borderRadius: 23, // in percent
                lineCount: 5,
                areaHeight: 2.3, // in blocks
                areaWeight: {
                    from: -30, // in degree
                    to: 50, // in degree
                },
            },
            sounds: {
                onHitBlock: {
                    soundIds: ['cso.warhammer.wall'],
                    pitch: 1,
                    volume: 1.5,
                },
                onHitEntity: {
                    soundIds: ['cso.warhammer.hit'],
                    pitch: 1,
                    volume: 1.5,
                },
                onMiss: {
                    soundIds: [''],
                    pitch: 1,
                    volume: 1.5,
                },
            },
            particles: {
                onHitBlock: {
                    particleIds: ['warhammer:wall'],
                },
                onHitEntity: {
                    particleIds: ['azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'warhammer:hurt'],
                },
            },
        };
        this.rightAttack = {
            enabled: true,
            damages: 118,
            delay: 23,
            displayCooldown: true,
            cooldown: 60,
            range: 4,
            precision: 0.07,
            knockback: {
                Ximpusle: 1.6,
                Zimpusle: 0.4,
            },
            sideAttack: {
                timeToSlash: 150, // in ms
                rayPerLine: 20,
                borderRadius: 23, // in percent
                lineCount: 5,
                areaHeight: 2.3, // in blocks
                areaWeight: {
                    from: -30, // in degree
                    to: 120, // in degree
                },
            },
            sounds: {
                onHitBlock: {
                    soundIds: ['cso.warhammer.wall'],
                    pitch: 1,
                    volume: 1.5,
                },
                onHitEntity: {
                    soundIds: ['cso.warhammer.hit'],
                    pitch: 1,
                    volume: 1.5,
                },
                onMiss: {
                    soundIds: [''],
                    pitch: 1,
                    volume: 1.5,
                },
            },
            particles: {
                onHitBlock: {
                    particleIds: ['warhammer:wall'],
                },
                onHitEntity: {
                    particleIds: ['azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'warhammer:hurt'],
                },
            },
        };
        // ATTACK on draw
        this.initialAttack = {
            enabled: true,
            damages: 59,
            delay: 5,
            cooldown: 10,
            disableItemDamage: true,
            displayCooldown: true,
            range: 4,
            precision: 0.07,
            knockback: {
                Ximpusle: 0.9,
                Zimpusle: 0.4,
            },
            sideAttack: {
                timeToSlash: 150, // in ms
                rayPerLine: 20,
                borderRadius: 23, // in percent
                lineCount: 5,
                areaHeight: 2.3, // in blocks
                areaWeight: {
                    from: -30, // in degree
                    to: 50, // in degree
                },
            },
            sounds: {
                onHitBlock: {
                    soundIds: ['cso.warhammer.wall'],
                    pitch: 1,
                    volume: 1.5,
                },
                onHitEntity: {
                    soundIds: ['cso.warhammer.hit'],
                    pitch: 1,
                    volume: 1.5,
                },
                onMiss: {
                    soundIds: [''],
                    pitch: 1,
                    volume: 1.5,
                },
            },
            particles: {
                onHitBlock: {
                    particleIds: ['warhammer:wall'],
                },
                onHitEntity: {
                    particleIds: ['azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'azoz:blood', 'warhammer:hurt'],
                },
            },
        };
        this.sounds = {
            onDraw: {
                soundIds: [''],
                pitch: 1,
                volume: 0.2,
            },
        };
        this.particles = {
            onDraw: {
                particleIds: ['warhammer:hit'],
            },
        };
        // Charge System
        this.charges = {
            enabled: false,
        };
        // KNOCKBACK
        this.knockback = {
            Ximpusle: 0.7,
            Zimpusle: 0.3,
        };
    }
}
