class Sounds {
    constructor() {
        this.volumeMultiplier = Sounds.DEFAULT_VOLUME;
    }
    static playForPlayer(sound, player) {
        if (sound && sound?.soundIds?.length > 0)
            player.playSound(Sounds.getRandomSoundId(sound), sound);
    }
    static play(sound, dimension, location) {
        if (sound && sound?.soundIds?.length > 0)
            dimension.playSound(Sounds.getRandomSoundId(sound), location, sound);
    }
    static getRandomSoundId(soundParams) {
        return soundParams.soundIds[Math.floor(Math.random() * soundParams.soundIds.length)];
    }
}
Sounds.DEFAULT_VOLUME = 1;
export default Sounds;
