export default class Timer {
    constructor() {
        this.ending = null;
        this.running = false;
        this.logs = {
            hasBeenSet: false,
            hasBeenReseted: false,
            endingValue: 0,
        };
    }
    setEnding(time) {
        this.ending = Date.now() + time;
        this.running = true;
        this.logs.hasBeenSet = true;
        this.logs.endingValue = time;
        return this;
    }
    freezeTime() {
        this.ending = this.ending + 10;
        this.running = true;
        this.logs.hasBeenSet = true;
        return this;
    }
    reset() {
        this.ending = Date.now();
        this.running = false;
        this.logs.hasBeenReseted = true;
    }
    get isFinished() {
        return Date.now() >= this.ending;
    }
}
