import { ContainerSlot, ItemStack } from '@minecraft/server';
import WeaponEventsHandler from 'events/melee.events.handler';
import MeleeWeapon from 'melee/melee-weapon';

export const CLEAR_TIMOUT: number = 3;

export type TCustomItemStack = (ContainerSlot | ItemStack) & {
	currentAmmo?(): number;
	updateLore?(): void;
	clear?(): void;
};

export default class ItemHandler {
	static item: boolean = true;

	public static isWeaponItem(item: TCustomItemStack, weapon: MeleeWeapon): boolean {
		return item?.typeId === weapon.itemTypeId;
	}
	public static isWeaponItemInstance(item: TCustomItemStack): boolean {
		for (const weapon of WeaponEventsHandler.MeleeSet) {
			if (item?.typeId === weapon.itemTypeId) return true;
			else continue;
		}
		return false;
	}
}
