import { Entity } from '@minecraft/server';
import CustomPlayer from '../../scripts/player/custom-player';
import { world } from '@minecraft/server';

export interface IAttackFunctions {
	onHitEntity?: TFunctions;
}

export type TFunctions = Array<string>

export abstract class Functions {
	public static execute(entity: Entity, functionName: string) {
		entity.runCommandAsync(`function ${functionName}`);
	}
	public static executeMany(entity: Entity, functions: TFunctions) {
		for (const functionName of functions) {
			this.execute(entity, functionName);
		}
	}
}
