import { Dimension, Vector3 } from '@minecraft/server';

export interface IParticleParams {
	particleIds?: Array<string>;
}

export interface IAttackParticles {
	onHitBlock?: IParticleParams;
	onHitEntity?: IParticleParams;
}

export interface IOtherParticles {
	onDraw?: IParticleParams;
}

export default class Particles {
	public static spawn(location: Vector3, dimension: Dimension, particles: IParticleParams['particleIds']) {
		if (particles && particles?.length > 0)
			for (const particleId of particles) {
				dimension.spawnParticle(particleId, location);
			}
	}
}
