

export interface IActionbarColors {
	done: string;
	default: string;
	gradient?: string[];
}

export class LoadingBar {
	protected finalValue: string;
	protected baseArray: string[];

	protected barLength: number;

	constructor(
		private timePerSquare: number, // in ms
		private barIcon: string,

		private barColors: IActionbarColors,

		private value1: number,
		private value2: number,
		private value3: number,
	) {}

	public create(): string {
		const timeRemaining = this.value2 - this.value3;

		this.barLength = Math.floor(this.value1 / this.timePerSquare)

		this.baseArray = Array(this.barLength).fill(this.barIcon);

		const arrayIndex = Math.floor((this.barLength * timeRemaining) / this.value1);
		this.baseArray.splice(arrayIndex <= 0 ? this.baseArray.length : arrayIndex, 0, arrayIndex <= 0 ? this.barColors.done : this.barColors.default);

		return this.barColors.done + this.baseArray.reverse().join('');
	}

	public get array() {
		return this.baseArray;
	}

	public get result() {
		return this.finalValue;
	}

	public fill(n: number, color: string): string {
		return this.baseArray.splice(n, 0, color).join('');
	}
}
